* PACKAGE DADMN  !" ϳ ᥤѡ
*"                  ver 1.02                   93/06/23 takepiro
**********************************************************************
      SUBROUTINE DYNMCS                      !"  ϳز
     M         ( GAU   , GAV   , GAW   , GAT   , 
     M           GATOR , GAPOR , 
     I           IT    , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
*"      Runge-Kutta ʬ( ʿڥȥ - ľåɶ )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY]
      REAL       GAU   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAV   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAW   ( IDIM, JDIM, 0:KDIM )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GATOR ( IDIM, JDIM, 0:KDIM )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, 0:KDIM )  !" ݥ 
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      INTEGER    IT                          !" ̤
      REAL       DELT                        !" ֹߦt
      LOGICAL    OADVNC                      !" 郎ʹԤ뤫ݤ
*"       :  ѿ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KDIM )            !" ٥()
      REAL       DRAD  ( 0:KDIM )            !" ()
*"        : ɸʻ
*
*   [INTERNAL SAVE]
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       RAYL                          !" 쥤꡼
      REAL       TAU                           !" ƥ顼
      REAL       PRND                          !" ץɥ
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
*
*   [INTERNAL PARAM]
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
      LOGICAL    ONONLN                        !" ϳإå
      SAVE       ONONLN
*
      LOGICAL    ODIASP
      DATA       ODIASP         / .TRUE. /
      SAVE       ODIASP
*
*   [INTERNAL WORK]
      REAL       GTUA  ( IDIM, JDIM, 0:KDIM )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KDIM )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM, JDIM, 0:KDIM )  !" ľưѲ֣
*
      REAL       GTUT  ( IDIM, JDIM, 0:KDIM )  !" ή  գ
      REAL       GTVT  ( IDIM, JDIM, 0:KDIM )  !" ̰ή  ֣
      REAL       GTWT  ( IDIM, JDIM, 0:KDIM )  !" ٱľή  ף
      REAL       GTH   ( IDIM, JDIM, 0:KDIM )  !" ٻѲ  
*"       : ʻѲ­
*"       : Ѳ
*
      REAL       WDTOR ( NMDIM , 0:KDIM     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KDIM     )  !" ݥ 
      REAL       WDDPOR( NMDIM , 0:KDIM     )  !" ݥ D_l 
      REAL       WDT   ( NMDIM , 0:KDIM     )  !"   
      SAVE       WDTOR , WDPOR , WDDPOR, WDT
*"       : ڥȥǡ
*
      REAL       WTTOR ( NMDIM, 0:KDIM      )  !" ȥ 
      REAL       WTPOR ( NMDIM, 0:KDIM      )  !" ݥ 
      REAL       WTT   ( NMDIM, 0:KDIM      )  !"   
*"       : ڥȥѲ
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      INTEGER    IORUNG                        !" Runge-Kutta 
      PARAMETER( IORUNG = 4 )
*
*
*"  << SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL    DPARM                     !" ѥ᥿
     O             ( RAYL   , TAU  , PRND  , 
     O               ONONLN                   )
*
         CALL HSPARM
     I          ( 'RAYLEIGH NUMBER', RAYL   )
         CALL HSPARM
     I          ( 'TAYLOR NUMBER'  , TAU**2 )
         CALL HSPARM
     I          ( 'PRANDTL NUMBER' , PRND   )
*
         CALL    DHSTRG                    !" 
*
         CALL GD2WD             !" ǡ򥹥ڥȥ
     O         ( WDTOR , WDPOR , WDT  , WDDPOR ,
     I           GATOR , GAPOR , GAT  ,
     C           FLAPLA,
     C           ARAD  , DRAD                     )
*
      ENDIF
*
*" << Runge-Kutta Loop >>
*
      ITRUNG = 0
*
 8888 CONTINUE                    !" <---  Runge-Kutta Loop : 
        ITRUNG = ITRUNG + 1 
*
         CALL DLOPER
     M           ( WDDPOR, 
     I             WDPOR ,
     F             'POS ',
     C             FLAPLA,
     C             ARAD  , DRAD    )
*
*
*" << TNDNCY : Ѳ >>
*
         IF( ONONLN )THEN
            CALL GRDDYN         !"  ϳع
     O         ( GTUA  , GTVA  , GTWA  , 
     O           GTUT  , GTVT  , GTWT  , GTH   ,
     I           GAU   , GAV   , GAW   , GAT   ,
     C           UVFACT, FLAPLA, 
     C           ALAT  , DLAT  , ARAD  , DRAD    )
*
         ELSE
            CALL RESET( GTUA , IDIM*JDIM*KMAX )
            CALL RESET( GTVA , IDIM*JDIM*KMAX )
            CALL RESET( GTWA , IDIM*JDIM*KMAX )
            CALL RESET( GTUT , IDIM*JDIM*KMAX )
            CALL RESET( GTVT , IDIM*JDIM*KMAX )
            CALL RESET( GTWT , IDIM*JDIM*KMAX )
            CALL RESET( GTH  , IDIM*JDIM*KMAX )
         ENDIF
*
         CALL GRDFRC            !" ϳس(ʻ)
     M         ( GTUA  , GTVA  , GTWA  , 
     M           GTUT  , GTVT  , GTWT  , GTH   ,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL TENG2W            !" Ѳ򥹥ڥȥ
     O         ( WTTOR , WTPOR , WTT   , 
     I           GTUA  , GTVA  , GTWA  , 
     I           GTUT  , GTVT  , GTWT  , GTH , 
     C           FLAPLA,
     C           ARAD  , DRAD                  )
*
        CALL LNDYN              !" ϳ 
     M         ( WTTOR , WTPOR , WTT   , 
     I           WDTOR , WDPOR , WDT   , WDDPOR, 
     C           RAYL  , TAU   , PRND  , 
     C           NMO   , FLAPLA, 
     C           ARAD  , DRAD                    )
*
*" << INTGR : ʬ >>
*
        CALL TINTGR             !" ڥȥʬ
     M         ( WDTOR , WDPOR , WDDPOR, WDT   , 
     I           WTTOR , WTPOR , WTT   , 
     I           DELT  , ITRUNG, 
     C           FLAPLA, 
     C           ARAD  , DRAD             )
*
        CALL GENGD              !" ʻͤ
     O         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     I           WDTOR , WDPOR , WDT   , 
     C           FLAPLA, UVFACT, 
     C           ARAD  , DRAD                    )
*
      IF ( ITRUNG . LT. IORUNG ) GOTO 8888  !" <--- Runge-Kutta Loop 
*
*" << OUTPUT :  >>
*
      CALL HISTIN ( GTUA  , 'UA' )  !" ΰ
      CALL HISTIN ( GTVA  , 'VA' )
      CALL HISTIN ( GTWA  , 'WA' )
      CALL HISTIN ( GTUT  , 'UT' )  !" ΰ
      CALL HISTIN ( GTVT  , 'VT' )
      CALL HISTIN ( GTWT  , 'WT' )
      CALL HISTIN ( GTH   , 'H'  )
*
      CALL DDIAG                       !" 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     C           PRND  , RAYL  , 
     C           ALAT  , ARAD                     )
*
      IF ( ODIASP ) THEN
        CALL SPCTLD                    !" ڥȥǤο
     I         ( WDTOR , 'TOR' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDPOR , 'POR' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDT   , 'TEMP', KMAX  , NMO   )
      ENDIF
*
      RETURN
*======================================================================
      ENTRY DSTRT                      !" ǡκ
     M         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     C           ALAT  , DLAT  , 
     C           ARAD  , DRAD                      )
*
*   [MODIFY]
*     REAL       GAU   ( IDIM, JDIM, 0:KDIM )  !"    
*     REAL       GAV   ( IDIM, JDIM, 0:KDIM )  !"    
*     REAL       GAW   ( IDIM, JDIM, 0:KDIM )  !" ľ 
*     REAL       GAT   ( IDIM, JDIM, 0:KDIM )  !"    
*
*   [OUTNPUT]
*     REAL       GATOR ( IDIM, JDIM, 0:KDIM )  !" ȥ 
*     REAL       GAPOR ( IDIM, JDIM, 0:KDIM )  !" ݥ 
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" 
*     REAL       DLAT  ( JDIM )              !" ٲٽ
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
      CALL STRTV                       !" ǡ
     M         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD                     ) 
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DHSTRG                !" ϳشطϤϿ
*
*   [INTERNAL PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
*
*   [INTERNAL WORK]
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS' , VMISS )   !" »
*
      CALL HISTRG                      !" Ͽ
     I       ( 'UA', 'x-mom.advection' ,' m/s**2   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL HISTRG                      !" Ͽ
     I       ( 'VA', 'y-mom.advection' ,' m/s**2   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL HISTRG                      !" Ͽ
     I       ( 'WA', 'z-mom.advection' ,' m/s**2   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL HISTRG                      !" Ͽ
     I       ( 'UT', 'x-adv.heat flux' ,'K m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL HISTRG                      !" Ͽ
     I       ( 'VT', 'y-adv.heat flux' ,'K m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL HISTRG                      !" Ͽ
     I       ( 'WT', 'z-adv.heat flux' ,'K m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL HISTRG                      !" Ͽ
     I       ( 'H', 'heating rate    ' ,'K/s  ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE  DPARM                 !" ѥ᥿
     O             ( RAYL   , TAU  , PRND  , 
     O               ONONLN                  )
*
*   [OUTPUT]
      REAL       RAYL                          !" 쥤꡼
      REAL       TAU                           !" ƥ顼
      REAL       PRND                          !" ץɥ
      LOGICAL    ONONLN                        !" ϳإå
*
*   [INTERNAL WORK]
      REAL       RAYLI                         !" 쥤꡼
      REAL       TAYLR                         !" ƥ顼
      REAL       PRNDL                         !" ץɥ
      LOGICAL    NONLIN                        !" ϳإå
*
      NAMELIST    /NMDYN/  RAYLI, TAYLR, PRNDL, NONLIN
*
      INTEGER    IFPAR, JFPAR
*
*"         < 1. NAMELIST ɤ߹ >
*
      RAYLI = 0.
      TAYLR = 0.
      PRNDL = 1.0
      NONLIN = .TRUE.
*
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMDYN , END=1190 )
 1190 WRITE  ( JFPAR, NMDYN  )
*
      RAYL   = RAYLI
      TAU    = SQRT( TAYLR )
      PRND   = PRNDL
      ONONLN = NONLIN
*
      RETURN
      END
