* PACKAGE DGFRC !" ϳ (ʻ)
*
*" [HIS] 93/06/25(takepiro)
*
**********************************************************************
      SUBROUTINE GRDFRC    !" (ʻ)
     M             ( GTUA  , GTVA  , GTWA  , 
     M               GTUT  , GTVT  , GTWT  , GTH  ,
     C               ALON  , DLON  , ALAT  , DLAT ,
     C               ARAD  , DRAD                    )
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZHDIM)                      !" ʸ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zhdim.F"                    !" ʸ
#endif
*
*   [MODIFY] 
      REAL       GTUA  ( IDIM*JDIM, 0:KDIM )  !" ưѲգ
      REAL       GTVA  ( IDIM*JDIM, 0:KDIM )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM*JDIM, 0:KDIM )  !" ľưѲ֣
*
      REAL       GTUT  ( IDIM*JDIM, 0:KDIM )  !" ή  գ
      REAL       GTVT  ( IDIM*JDIM, 0:KDIM )  !" ̰ή  ֣
      REAL       GTWT  ( IDIM*JDIM, 0:KDIM )  !" ٱľή  ף
      REAL       GTH   ( IDIM*JDIM, 0:KDIM )  !" ٻѲ  
*
*   [INPUT]
      REAL       ALON  ( IDIM )               !" 
      REAL       DLON  ( IDIM )               !" ٲٽ
      REAL       ALAT  ( JDIM )               !" 
      REAL       DLAT  ( JDIM )               !" ٲٽ
      REAL       ARAD  ( 0:KDIM )             !" ٥()
      REAL       DRAD  ( 0:KDIM )             !" ()
*
*   [INTERNAL SAVE]
      REAL       FRCU ( IDIM*JDIM , 0:KDIM )  !"  ƣ
      REAL       FRCV ( IDIM*JDIM , 0:KDIM )  !"  ƣ
      REAL       FRCW ( IDIM*JDIM , 0:KDIM )  !"  ƣ
*
      REAL       FLUT ( IDIM*JDIM , 0:KDIM )  !"  գ
      REAL       FLVT ( IDIM*JDIM , 0:KDIM )  !"  ֣
      REAL       FLWT ( IDIM*JDIM , 0:KDIM )  !"  ף
*
      REAL       FHT  ( IDIM*JDIM , 0:KDIM )  !"  
*
      SAVE       FRCU , FRCV , FRCW , 
     &           FLUT , FLVT , FLWT , FHT
*
*   [INTERNAL WORK] 
      INTEGER    IFPAR, JFPAR
      INTEGER    IJ , K
*
*   [INTERNAL PARM] 
      CHARACTER  FILEUA  *(NFILN)             !" ե
      CHARACTER  FILEVA  *(NFILN)             !" ե
      CHARACTER  FILEWA  *(NFILN)             !" ե
      CHARACTER  FILEUT  *(NFILN)             !" ե
      CHARACTER  FILEVT  *(NFILN)             !" ե
      CHARACTER  FILEWT  *(NFILN)             !" ե
      CHARACTER  FILEH   *(NFILN)             !" ե
      DATA       FILEUA, FILEVA, FILEWA, 
     &           FILEUT, FILEVT, FILEWT, FILEH / 7 * ' ' /
*
      NAMELIST  /NMFORC/ FILEUA, FILEVA, FILEWA, 
     &                   FILEUT, FILEVT, FILEWT, FILEH
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      INTEGER    ITNPHI
      DATA       ITNPHI / -999 /
*
*"         < 1.  ɤ߹ >
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         WRITE ( 6,* ) ' STEADY FORCING:  DATE=93/07/14'
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMFORC, END=1190 )
 1190    WRITE  ( JFPAR, NMFORC )
*
         CALL RDCON
     O         ( FRCU  , ITNPHI ,
     I           FILEUA, 'UA'   , 0.    , 'ALEV'  ,  0     )
         CALL RDCON
     O         ( FRCV  , ITNPHI ,
     I           FILEVA, 'VA'   , 0.    , 'ALEV'  ,  0     )
         CALL RDCON
     O         ( FRCW  , ITNPHI ,
     I           FILEWA, 'WA'   , 0.    , 'ALEV'  ,  0     )
*
         CALL RDCON
     O         ( FLUT  , ITNPHI ,
     I           FILEUT, 'UT'   , 0.    , 'ALEV'  ,  0     )
         CALL RDCON
     O         ( FLVT  , ITNPHI ,
     I           FILEVT, 'VT'   , 0.    , 'ALEV'  ,  0     )
         CALL RDCON
     O         ( FLWT  , ITNPHI ,
     I           FILEWT, 'WT'   , 0.    , 'ALEV'  ,  0     )
         CALL RDCON
     O         ( FHT   , ITNPHI ,
     I           FILEH , 'H'    , 0.    , 'ALEV'  ,  0     )
*
      ENDIF
*
*"         < 2. ʻѲ >
*
      DO 1100 K = 0, KDIM
         DO 1100 IJ = 1, IDIM*JDIM
            GTUA( IJ, K ) = GTUA( IJ, K ) +  FRCU( IJ, K )
            GTVA( IJ, K ) = GTVA( IJ, K ) +  FRCV( IJ, K )
            GTWA( IJ, K ) = GTWA( IJ, K ) +  FRCW( IJ, K )
*
            GTUT( IJ, K ) = GTUT( IJ, K ) +  FLUT( IJ, K )
            GTVT( IJ, K ) = GTVT( IJ, K ) +  FLVT( IJ, K )
            GTWT( IJ, K ) = GTWT( IJ, K ) +  FLWT( IJ, K )
            GTH ( IJ, K ) = GTH ( IJ, K ) +  FHT ( IJ, K )
 1100 CONTINUE

      RETURN
      END
