* PACKAGE APCON  !"  ɸʪå
*
*"  [HIS] 92/09/10(takepiro)
*"        93/09/15(takepiro)
*
*********************************************************************
      SUBROUTINE PCONST        !" ɸʪ
*
#ifdef SYS_IBMS
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zccom.F"                    !" ɸʪ
#endif
*
*"    COMMON /COMCON/
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*
*    [INTERNAL WORK]
      INTEGER    IFPAR, JFPAR
      LOGICAL    LEPSL
*
*    [EXTERNAL FUNC]
      LOGICAL    LREQ

      NAMELIST    /NMPCON/ ERI   , ERO   , ETA
*
      ERI = 0.0
      ERO = 0.0
      ETA = 0.0
*
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMPCON, END=190 )
 190  WRITE  ( JFPAR, NMPCON )
*
      CALL GLPGET( 'LEPSL', LEPSL )
      IF ( .NOT.LEPSL )THEN
         CALL GLPSET( 'LEPSL', .TRUE. )
      ENDIF
*
      IF ( ( 0.0 .LT. ETA ) .AND. ( ETA. LT. 1.0 ) )THEN
         IF( ( ERO .EQ. 0.0 ) .AND. ( ERI .EQ. 0.0 ) ) THEN
            CALL MSGDMP('W','PCONST','ERI, ERO EVALUATED AUTOMATICALLY')
            ERO = 1.0 / ( 1.0 - ETA )
            ERI = ETA * ERO
            WRITE  ( JFPAR, NMPCON )
         ELSE IF( ( ERO .GT. 0.0 ) .AND. ( ERI .EQ. 0.0 ) ) THEN
            CALL MSGDMP('W','PCONST','ERI EVALUATED AUTOMATICALLY')
            ERI = ETA * ERO
            WRITE  ( JFPAR, NMPCON )
         ELSE IF( ( ERO .EQ. 0.0 ) .AND. ( ERI .GT. 0.0 ) ) THEN
            CALL MSGDMP('W','PCONST','ERO EVALUATED AUTOMATICALLY')
            ERO = ERI / ETA
            WRITE  ( JFPAR, NMPCON )
         ELSE IF( .NOT. LREQ( ERI/ERO, ETA ) )THEN
            CALL MSGDMP('E','PCONST', 'ERI,ERO AND ETA NOT CONSISTENT' )
         ENDIF
      ELSE IF( ( ERO .GT. ERI ) .AND. ( ERI .GT. 0.0 ) ) THEN
         CALL MSGDMP('W','PCONST','ETA EVALUATED AUTOMATICALLY')
         ETA = ERI / ERO
         WRITE  ( JFPAR, NMPCON )
      ELSE
         CALL MSGDMP('E','PCONST', 'ERI, ERO, ETA NOT CORRECT' )
      ENDIF
*
      IF ( .NOT.LEPSL )THEN
         CALL GLPSET( 'LEPSL', .FALSE. )
      ENDIF
*      
      RETURN
      END
